#ifndef _DEVICE_PROFILE_H_
#define _DEVICE_PROFILE_H_

#include "PrivateProf.h"
#include <vector>
#include <string>
typedef std::basic_string<TCHAR> tstring;

typedef struct _ENUM_CLASS {
	tstring name;
	GUID guid;
	DWORD flag;
} ENUM_CLASS;

class DeviceProfile : public PrivateProfile
{
public:
	DeviceProfile(void);
	virtual ~DeviceProfile(void);

	BOOL Load(void);
	size_t size(void);
	ENUM_CLASS operator[](int idx){ return enumClass[idx]; };

	std::vector <tstring> allowList() { return allowName; };
	std::vector <tstring> denyList() { return denyName; };

protected:
	std::vector <ENUM_CLASS> enumClass;
	std::vector <tstring> allowName, denyName;
};

#endif//_DEVICE_PROFILE_H_
