#ifndef _MAIN_DIALOG_H_
#define _MAIN_DIALOG_H_

#include "ReposDialog.h"
#include "DeviceProf.h"
#include <commctrl.h>
#include "DeviceMan.h"
#include "AboutDlg.h"

#define _NUMBER_OF_COLUMN	3

class MainDialog : public ReposDialog
{
public:
	MainDialog( UINT idResource );
	~MainDialog(void);

	virtual BOOL DoModeless(HWND hParent = NULL, int nCmdShow = SW_SHOW);

	typedef enum _SORT_METHOD {
		SORT_NONE,
		SORT_UP,
		SORT_DOWN,
	} SORT_METHOD;
	typedef struct _SORT_CONTEXT {
		HWND hList;
		int sortSubItem;
		SORT_METHOD sortMethod;
	} SORT_CONTEXT;
	static int CALLBACK SortCompareProc( LPARAM lp1, LPARAM lp2, LPARAM lp3 );

protected:
	DeviceProfile deviceProf;
	HIMAGELIST imageList;
	DeviceManipulator devMan;
	int curSel;
	size_t numSelected;
	HWND hList;
	SORT_METHOD sortMethod[_NUMBER_OF_COLUMN];
	AboutDlg *m_aboutDlg;

	BOOL Cls_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
	void Cls_OnSysCommand(HWND hwnd, UINT cmd, int x, int y);
	void Cls_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
	void Cls_OnDestroy(HWND hwnd);

	void Cls_OnDevManEnumEnd( void );
	void Cls_OnDevManDelEnd( void );
	void Cls_OnDevManDevChg( int idx, REMOVE_STATE state );
	BOOL Cls_OnNotify( WPARAM wParam, LPARAM lParam );

	INT_PTR CALLBACK DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam );
	BOOL InitInstance( HWND hParent = NULL );
	void InsertSystemMenu(void);
	int InitControls(void);
	int ListInsertItem( DISPLAY_LOG newline );

	void CalcMinSize(void);
	void MainSetMin( POINT *pt );
	void UpdateList(void);

	int GetImageIndex( REMOVE_STATE state );
	void UpdateHeaderSortIcon( void );
	void ClearSortMethod( void );

	static void GetListViewItemText( HWND hWndList, int idx, int sub, tstring &str );

	typedef enum _UI_STATE {
		STATE_INITIAL,
		STATE_INSEARCH,
		STATE_DEVEXIST,
		STATE_INDELETE,
	} UI_STATE;
	void SetButtonState( UI_STATE state );
};

#endif//_MAIN_DIALOG_H_
