#ifndef _REPOS_DIALOG_H_
#define _REPOS_DIALOG_H_

#include "Dialog.h"

class ReposDialog : public Dialog
{
public:
	ReposDialog(UINT idResource);
	virtual ~ReposDialog(void);
	void ReposProc( UINT uMsg, WPARAM wParam, LPARAM lParam );

	virtual void ReposInit(void);
	void ReposResize( int cx, int cy );
	void ReposSetMin( POINT *pt );

protected:
	typedef enum _ANCHOR_TYPE {
		ANCHOR_LEFT		= 1,
		ANCHOR_TOP		= 2,
		ANCHOR_RIGHT	= 4,
		ANCHOR_BOTTOM	= 8,
	} ANCHOR_TYPE;

	const static int ANCHOR_MASK_HORIZON = ANCHOR_LEFT | ANCHOR_RIGHT;
	const static int ANCHOR_MASK_VERTICAL = ANCHOR_TOP | ANCHOR_BOTTOM;

	typedef struct _REPOS_ITEM {
		DWORD	id;
		DWORD	flag;
		RECT	inipos;
	} REPOS_ITEM;

	REPOS_ITEM *reposItems;
	int reposNum;
	RECT prevWinRect;
	POINT ptMinSize;
};

#endif//_REPOS_DIALOG_H_
