#include "StdAfx.h"
#include "Thread.h"

Thread::Thread(void)
	: m_hThread( NULL )
	, m_bLoop( TRUE )
{
}

Thread::~Thread(void)
{
	if ( m_hThread ) Exit();
}

DWORD WINAPI Thread::_threadStatic( void *pObject )
{
	Thread *pThis = (Thread*)pObject;
	return pThis->ThreadProc();
}

DWORD Thread::ThreadProc(void)
{
	while( m_bLoop ) {
		EternalProc();
	}
	return 0;
}

void Thread::EternalProc(void)
{
}

BOOL Thread::Create()
{
	DWORD threadID;

	m_bLoop = TRUE;

	m_hThread = CreateThread(
					(LPSECURITY_ATTRIBUTES)NULL,
					0,
					(LPTHREAD_START_ROUTINE)_threadStatic,
					this,
					0,
					&threadID
					);

	return m_hThread ? TRUE : FALSE;
}

BOOL Thread::Join( DWORD dwTimeout )
{
	BOOL bRet = FALSE;

	if ( m_hThread ) {
		if ( WaitForSingleObject( m_hThread, dwTimeout ) == WAIT_OBJECT_0 ) {
			CloseHandle( m_hThread );
			m_hThread = NULL;
			bRet = TRUE;
		}
	}

	return bRet;
}

BOOL Thread::Exit( DWORD dwTimeout )
{
	m_bLoop = FALSE;
	return Join( dwTimeout );
}
